commit a7812ae412311d7d47f8aa85656faadac9d64b56
Author: pbrook <pbrook@c046a42c-6fe2-441c-8c8c-71466251a162>
Date:   Mon Nov 17 14:43:54 2008 +0000

    TCG variable type checking.
    
    Signed-off-by: Paul Brook <paul@codesourcery.com>
    
    
    git-svn-id: svn://svn.savannah.nongnu.org/qemu/trunk@5729 c046a42c-6fe2-441c-8c8c-71466251a162

diff --git a/target-mips/translate.c b/target-mips/translate.c
index cefccb0..590c2b6 100644
--- a/target-mips/translate.c
+++ b/target-mips/translate.c
@@ -29,10 +29,13 @@
 #include "cpu.h"
 #include "exec-all.h"
 #include "disas.h"
-#include "helper.h"
 #include "tcg-op.h"
 #include "qemu-common.h"
 
+#include "helper.h"
+#define GEN_HELPER 1
+#include "helper.h"
+
 //#define MIPS_DEBUG_DISAS
 //#define MIPS_DEBUG_SIGN_EXTENSIONS
 //#define MIPS_SINGLE_STEP
@@ -423,101 +426,40 @@ enum {
 };
 
 /* global register indices */
-static TCGv cpu_env, cpu_gpr[32], cpu_PC;
+static TCGv_ptr cpu_env;
+static TCGv cpu_gpr[32], cpu_PC;
 static TCGv cpu_HI[MIPS_DSP_ACC], cpu_LO[MIPS_DSP_ACC], cpu_ACX[MIPS_DSP_ACC];
-static TCGv cpu_dspctrl, bcond, btarget;
-static TCGv fpu_fpr32[32], fpu_fpr32h[32], fpu_fpr64[32], fpu_fcr0, fpu_fcr31;
+static TCGv cpu_dspctrl, btarget;
+static TCGv_i32 bcond;
+static TCGv_i32 fpu_fpr32[32], fpu_fpr32h[32];
+static TCGv_i64 fpu_fpr64[32];
+static TCGv_i32 fpu_fcr0, fpu_fcr31;
 
 #include "gen-icount.h"
 
-static inline void tcg_gen_helper_0_i(void *func, uint32_t arg)
-
-{
-    TCGv tmp = tcg_const_i32(arg);
-
-    tcg_gen_helper_0_1(func, tmp);
-    tcg_temp_free(tmp);
-}
-
-static inline void tcg_gen_helper_0_ii(void *func, uint32_t arg1, uint32_t arg2)
-{
-    TCGv tmp1 = tcg_const_i32(arg1);
-    TCGv tmp2 = tcg_const_i32(arg2);
-
-    tcg_gen_helper_0_2(func, tmp1, tmp2);
-    tcg_temp_free(tmp1);
-    tcg_temp_free(tmp2);
-}
-
-static inline void tcg_gen_helper_0_1i(void *func, TCGv arg1, uint32_t arg2)
-{
-    TCGv tmp = tcg_const_i32(arg2);
-
-    tcg_gen_helper_0_2(func, arg1, tmp);
-    tcg_temp_free(tmp);
-}
-
-static inline void tcg_gen_helper_0_2i(void *func, TCGv arg1, TCGv arg2, uint32_t arg3)
-{
-    TCGv tmp = tcg_const_i32(arg3);
-
-    tcg_gen_helper_0_3(func, arg1, arg2, tmp);
-    tcg_temp_free(tmp);
-}
-
-static inline void tcg_gen_helper_0_1ii(void *func, TCGv arg1, uint32_t arg2, uint32_t arg3)
-{
-    TCGv tmp1 = tcg_const_i32(arg2);
-    TCGv tmp2 = tcg_const_i32(arg3);
-
-    tcg_gen_helper_0_3(func, arg1, tmp1, tmp2);
-    tcg_temp_free(tmp1);
-    tcg_temp_free(tmp2);
-}
-
-static inline void tcg_gen_helper_1_i(void *func, TCGv ret, uint32_t arg)
-{
-    TCGv tmp = tcg_const_i32(arg);
-
-    tcg_gen_helper_1_1(func, ret, tmp);
-    tcg_temp_free(tmp);
-}
-
-static inline void tcg_gen_helper_1_1i(void *func, TCGv ret, TCGv arg1, uint32_t arg2)
-{
-    TCGv tmp = tcg_const_i32(arg2);
-
-    tcg_gen_helper_1_2(func, ret, arg1, tmp);
-    tcg_temp_free(tmp);
-}
-
-static inline void tcg_gen_helper_1_1ii(void *func, TCGv ret, TCGv arg1, uint32_t arg2, uint32_t arg3)
-{
-    TCGv tmp1 = tcg_const_i32(arg2);
-    TCGv tmp2 = tcg_const_i32(arg3);
-
-    tcg_gen_helper_1_3(func, ret, arg1, tmp1, tmp2);
-    tcg_temp_free(tmp1);
-    tcg_temp_free(tmp2);
-}
-
-static inline void tcg_gen_helper_1_2i(void *func, TCGv ret, TCGv arg1, TCGv arg2, uint32_t arg3)
-{
-    TCGv tmp = tcg_const_i32(arg3);
+#define gen_helper_0i(name, arg) do {                             \
+    TCGv_i32 helper_tmp = tcg_const_i32(arg);                     \
+    gen_helper_##name(helper_tmp);                                \
+    tcg_temp_free_i32(helper_tmp);                                \
+    } while(0)
 
-    tcg_gen_helper_1_3(func, ret, arg1, arg2, tmp);
-    tcg_temp_free(tmp);
-}
+#define gen_helper_1i(name, arg1, arg2) do {                      \
+    TCGv_i32 helper_tmp = tcg_const_i32(arg2);                    \
+    gen_helper_##name(arg1, helper_tmp);                          \
+    tcg_temp_free_i32(helper_tmp);                                \
+    } while(0)
 
-static inline void tcg_gen_helper_1_2ii(void *func, TCGv ret, TCGv arg1, TCGv arg2, uint32_t arg3, uint32_t arg4)
-{
-    TCGv tmp1 = tcg_const_i32(arg3);
-    TCGv tmp2 = tcg_const_i32(arg4);
+#define gen_helper_2i(name, arg1, arg2, arg3) do {                \
+    TCGv_i32 helper_tmp = tcg_const_i32(arg3);                    \
+    gen_helper_##name(arg1, arg2, helper_tmp);                    \
+    tcg_temp_free_i32(helper_tmp);                                \
+    } while(0)
 
-    tcg_gen_helper_1_4(func, ret, arg1, arg2, tmp1, tmp2);
-    tcg_temp_free(tmp1);
-    tcg_temp_free(tmp2);
-}
+#define gen_helper_3i(name, arg1, arg2, arg3, arg4) do {          \
+    TCGv_i32 helper_tmp = tcg_const_i32(arg4);                    \
+    gen_helper_##name(arg1, arg2, arg3, helper_tmp);              \
+    tcg_temp_free_i32(helper_tmp);                                \
+    } while(0)
 
 typedef struct DisasContext {
     struct TranslationBlock *tb;
@@ -618,21 +560,24 @@ static inline void gen_store_ACX (TCGv t, int reg)
 /* Moves to/from shadow registers. */
 static inline void gen_load_srsgpr (int from, int to)
 {
-    TCGv r_tmp1 = tcg_temp_new(TCG_TYPE_TL);
+    TCGv r_tmp1 = tcg_temp_new();
 
     if (from == 0)
         tcg_gen_movi_tl(r_tmp1, 0);
     else {
-        TCGv r_tmp2 = tcg_temp_new(TCG_TYPE_I32);
+        TCGv_i32 r_tmp2 = tcg_temp_new_i32();
+        TCGv_ptr addr = tcg_temp_new_ptr();
 
         tcg_gen_ld_i32(r_tmp2, cpu_env, offsetof(CPUState, CP0_SRSCtl));
         tcg_gen_shri_i32(r_tmp2, r_tmp2, CP0SRSCtl_PSS);
         tcg_gen_andi_i32(r_tmp2, r_tmp2, 0xf);
         tcg_gen_muli_i32(r_tmp2, r_tmp2, sizeof(target_ulong) * 32);
-        tcg_gen_add_i32(r_tmp2, cpu_env, r_tmp2);
+        tcg_gen_ext_i32_ptr(addr, r_tmp2);
+        tcg_gen_add_ptr(addr, cpu_env, addr);
 
-        tcg_gen_ld_tl(r_tmp1, r_tmp2, sizeof(target_ulong) * from);
-        tcg_temp_free(r_tmp2);
+        tcg_gen_ld_tl(r_tmp1, addr, sizeof(target_ulong) * from);
+        tcg_temp_free_ptr(addr);
+        tcg_temp_free_i32(r_tmp2);
     }
     gen_store_gpr(r_tmp1, to);
     tcg_temp_free(r_tmp1);
@@ -641,34 +586,37 @@ static inline void gen_load_srsgpr (int from, int to)
 static inline void gen_store_srsgpr (int from, int to)
 {
     if (to != 0) {
-        TCGv r_tmp1 = tcg_temp_new(TCG_TYPE_TL);
-        TCGv r_tmp2 = tcg_temp_new(TCG_TYPE_I32);
+        TCGv r_tmp1 = tcg_temp_new();
+        TCGv_i32 r_tmp2 = tcg_temp_new_i32();
+        TCGv_ptr addr = tcg_temp_new_ptr();
 
         gen_load_gpr(r_tmp1, from);
         tcg_gen_ld_i32(r_tmp2, cpu_env, offsetof(CPUState, CP0_SRSCtl));
         tcg_gen_shri_i32(r_tmp2, r_tmp2, CP0SRSCtl_PSS);
         tcg_gen_andi_i32(r_tmp2, r_tmp2, 0xf);
         tcg_gen_muli_i32(r_tmp2, r_tmp2, sizeof(target_ulong) * 32);
-        tcg_gen_add_i32(r_tmp2, cpu_env, r_tmp2);
+        tcg_gen_ext_i32_ptr(addr, r_tmp2);
+        tcg_gen_add_ptr(addr, cpu_env, addr);
 
-        tcg_gen_st_tl(r_tmp1, r_tmp2, sizeof(target_ulong) * to);
+        tcg_gen_st_tl(r_tmp1, addr, sizeof(target_ulong) * to);
+        tcg_temp_free_ptr(addr);
+        tcg_temp_free_i32(r_tmp2);
         tcg_temp_free(r_tmp1);
-        tcg_temp_free(r_tmp2);
     }
 }
 
 /* Floating point register moves. */
-static inline void gen_load_fpr32 (TCGv t, int reg)
+static inline void gen_load_fpr32 (TCGv_i32 t, int reg)
 {
     tcg_gen_mov_i32(t, fpu_fpr32[reg]);
 }
 
-static inline void gen_store_fpr32 (TCGv t, int reg)
+static inline void gen_store_fpr32 (TCGv_i32 t, int reg)
 {
     tcg_gen_mov_i32(fpu_fpr32[reg], t);
 }
 
-static inline void gen_load_fpr64 (DisasContext *ctx, TCGv t, int reg)
+static inline void gen_load_fpr64 (DisasContext *ctx, TCGv_i64 t, int reg)
 {
     if (ctx->hflags & MIPS_HFLAG_F64)
         tcg_gen_mov_i64(t, fpu_fpr64[reg]);
@@ -677,7 +625,7 @@ static inline void gen_load_fpr64 (DisasContext *ctx, TCGv t, int reg)
     }
 }
 
-static inline void gen_store_fpr64 (DisasContext *ctx, TCGv t, int reg)
+static inline void gen_store_fpr64 (DisasContext *ctx, TCGv_i64 t, int reg)
 {
     if (ctx->hflags & MIPS_HFLAG_F64)
         tcg_gen_mov_i64(fpu_fpr64[reg], t);
@@ -688,63 +636,61 @@ static inline void gen_store_fpr64 (DisasContext *ctx, TCGv t, int reg)
     }
 }
 
-static inline void gen_load_fpr32h (TCGv t, int reg)
+static inline void gen_load_fpr32h (TCGv_i32 t, int reg)
 {
     tcg_gen_mov_i32(t, fpu_fpr32h[reg]);
 }
 
-static inline void gen_store_fpr32h (TCGv t, int reg)
+static inline void gen_store_fpr32h (TCGv_i32 t, int reg)
 {
     tcg_gen_mov_i32(fpu_fpr32h[reg], t);
 }
 
-static inline void get_fp_cond (TCGv t)
+static inline void get_fp_cond (TCGv_i32 t)
 {
-    TCGv r_tmp1 = tcg_temp_new(TCG_TYPE_I32);
-    TCGv r_tmp2 = tcg_temp_new(TCG_TYPE_I32);
+    TCGv_i32 r_tmp1 = tcg_temp_new_i32();
+    TCGv_i32 r_tmp2 = tcg_temp_new_i32();
 
     tcg_gen_shri_i32(r_tmp2, fpu_fcr31, 24);
     tcg_gen_andi_i32(r_tmp2, r_tmp2, 0xfe);
     tcg_gen_shri_i32(r_tmp1, fpu_fcr31, 23);
     tcg_gen_andi_i32(r_tmp1, r_tmp1, 0x1);
     tcg_gen_or_i32(t, r_tmp1, r_tmp2);
-    tcg_temp_free(r_tmp1);
-    tcg_temp_free(r_tmp2);
+    tcg_temp_free_i32(r_tmp1);
+    tcg_temp_free_i32(r_tmp2);
 }
 
-typedef void (fcmp_fun32)(uint32_t, uint32_t, int);
-typedef void (fcmp_fun64)(uint64_t, uint64_t, int);
-
-#define FOP_CONDS(fcmp_fun, type, fmt)                                        \
-static fcmp_fun * fcmp ## type ## _ ## fmt ## _table[16] = {                  \
-    do_cmp ## type ## _ ## fmt ## _f,                                         \
-    do_cmp ## type ## _ ## fmt ## _un,                                        \
-    do_cmp ## type ## _ ## fmt ## _eq,                                        \
-    do_cmp ## type ## _ ## fmt ## _ueq,                                       \
-    do_cmp ## type ## _ ## fmt ## _olt,                                       \
-    do_cmp ## type ## _ ## fmt ## _ult,                                       \
-    do_cmp ## type ## _ ## fmt ## _ole,                                       \
-    do_cmp ## type ## _ ## fmt ## _ule,                                       \
-    do_cmp ## type ## _ ## fmt ## _sf,                                        \
-    do_cmp ## type ## _ ## fmt ## _ngle,                                      \
-    do_cmp ## type ## _ ## fmt ## _seq,                                       \
-    do_cmp ## type ## _ ## fmt ## _ngl,                                       \
-    do_cmp ## type ## _ ## fmt ## _lt,                                        \
-    do_cmp ## type ## _ ## fmt ## _nge,                                       \
-    do_cmp ## type ## _ ## fmt ## _le,                                        \
-    do_cmp ## type ## _ ## fmt ## _ngt,                                       \
-};                                                                            \
-static inline void gen_cmp ## type ## _ ## fmt(int n, TCGv a, TCGv b, int cc) \
+#define FOP_CONDS(type, fmt, bits)                                            \
+static inline void gen_cmp ## type ## _ ## fmt(int n, TCGv_i##bits a,         \
+                                               TCGv_i##bits b, int cc)        \
 {                                                                             \
-    tcg_gen_helper_0_2i(fcmp ## type ## _ ## fmt ## _table[n], a, b, cc);     \
+    switch (n) {                                                              \
+    case  0: gen_helper_2i(cmp ## type ## _ ## fmt ## _f, a, b, cc);    break;\
+    case  1: gen_helper_2i(cmp ## type ## _ ## fmt ## _un, a, b, cc);   break;\
+    case  2: gen_helper_2i(cmp ## type ## _ ## fmt ## _eq, a, b, cc);   break;\
+    case  3: gen_helper_2i(cmp ## type ## _ ## fmt ## _ueq, a, b, cc);  break;\
+    case  4: gen_helper_2i(cmp ## type ## _ ## fmt ## _olt, a, b, cc);  break;\
+    case  5: gen_helper_2i(cmp ## type ## _ ## fmt ## _ult, a, b, cc);  break;\
+    case  6: gen_helper_2i(cmp ## type ## _ ## fmt ## _ole, a, b, cc);  break;\
+    case  7: gen_helper_2i(cmp ## type ## _ ## fmt ## _ule, a, b, cc);  break;\
+    case  8: gen_helper_2i(cmp ## type ## _ ## fmt ## _sf, a, b, cc);   break;\
+    case  9: gen_helper_2i(cmp ## type ## _ ## fmt ## _ngle, a, b, cc); break;\
+    case 10: gen_helper_2i(cmp ## type ## _ ## fmt ## _seq, a, b, cc);  break;\
+    case 11: gen_helper_2i(cmp ## type ## _ ## fmt ## _ngl, a, b, cc);  break;\
+    case 12: gen_helper_2i(cmp ## type ## _ ## fmt ## _lt, a, b, cc);   break;\
+    case 13: gen_helper_2i(cmp ## type ## _ ## fmt ## _nge, a, b, cc);  break;\
+    case 14: gen_helper_2i(cmp ## type ## _ ## fmt ## _le, a, b, cc);   break;\
+    case 15: gen_helper_2i(cmp ## type ## _ ## fmt ## _ngt, a, b, cc);  break;\
+    default: abort();                                                         \
+    }                                                                         \
 }
 
-FOP_CONDS(fcmp_fun64, , d)
-FOP_CONDS(fcmp_fun64, abs, d)
-FOP_CONDS(fcmp_fun32, , s)
-FOP_CONDS(fcmp_fun32, abs, s)
-FOP_CONDS(fcmp_fun64, , ps)
-FOP_CONDS(fcmp_fun64, abs, ps)
+FOP_CONDS(, d, 64)
+FOP_CONDS(abs, d, 64)
+FOP_CONDS(, s, 32)
+FOP_CONDS(abs, s, 32)
+FOP_CONDS(, ps, 64)
+FOP_CONDS(abs, ps, 64)
 #undef FOP_CONDS
 
 /* Tests */
@@ -823,11 +769,11 @@ static inline void save_cpu_state (DisasContext *ctx, int do_save_pc)
         ctx->saved_pc = ctx->pc;
     }
     if (ctx->hflags != ctx->saved_hflags) {
-        TCGv r_tmp = tcg_temp_new(TCG_TYPE_I32);
+        TCGv_i32 r_tmp = tcg_temp_new_i32();
 
         tcg_gen_movi_i32(r_tmp, ctx->hflags);
         tcg_gen_st_i32(r_tmp, cpu_env, offsetof(CPUState, hflags));
-        tcg_temp_free(r_tmp);
+        tcg_temp_free_i32(r_tmp);
         ctx->saved_hflags = ctx->hflags;
         switch (ctx->hflags & MIPS_HFLAG_BMASK) {
         case MIPS_HFLAG_BR:
@@ -858,9 +804,13 @@ static inline void restore_cpu_state (CPUState *env, DisasContext *ctx)
 static inline void
 generate_exception_err (DisasContext *ctx, int excp, int err)
 {
+    TCGv_i32 texcp = tcg_const_i32(excp);
+    TCGv_i32 terr = tcg_const_i32(err);
     save_cpu_state(ctx, 1);
-    tcg_gen_helper_0_ii(do_raise_exception_err, excp, err);
-    tcg_gen_helper_0_0(do_interrupt_restart);
+    gen_helper_raise_exception_err(texcp, terr);
+    tcg_temp_free_i32(terr);
+    tcg_temp_free_i32(texcp);
+    gen_helper_interrupt_restart();
     tcg_gen_exit_tb(0);
 }
 
@@ -868,8 +818,8 @@ static inline void
 generate_exception (DisasContext *ctx, int excp)
 {
     save_cpu_state(ctx, 1);
-    tcg_gen_helper_0_i(do_raise_exception, excp);
-    tcg_gen_helper_0_0(do_interrupt_restart);
+    gen_helper_0i(raise_exception, excp);
+    gen_helper_interrupt_restart();
     tcg_gen_exit_tb(0);
 }
 
@@ -999,7 +949,7 @@ OP_LD_ATOMIC(lld,ld64);
 #define OP_ST_ATOMIC(insn,fname,almask)                                 \
 static inline void op_ldst_##insn(TCGv t0, TCGv t1, DisasContext *ctx)  \
 {                                                                       \
-    TCGv r_tmp = tcg_temp_local_new(TCG_TYPE_TL);                       \
+    TCGv r_tmp = tcg_temp_local_new();                       \
     int l1 = gen_new_label();                                           \
     int l2 = gen_new_label();                                           \
     int l3 = gen_new_label();                                           \
@@ -1030,8 +980,8 @@ static void gen_ldst (DisasContext *ctx, uint32_t opc, int rt,
                       int base, int16_t offset)
 {
     const char *opn = "ldst";
-    TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
-    TCGv t1 = tcg_temp_local_new(TCG_TYPE_TL);
+    TCGv t0 = tcg_temp_local_new();
+    TCGv t1 = tcg_temp_local_new();
 
     if (base == 0) {
         tcg_gen_movi_tl(t0, offset);
@@ -1076,27 +1026,27 @@ static void gen_ldst (DisasContext *ctx, uint32_t opc, int rt,
     case OPC_LDL:
         save_cpu_state(ctx, 1);
         gen_load_gpr(t1, rt);
-        tcg_gen_helper_1_2i(do_ldl, t1, t0, t1, ctx->mem_idx);
+        gen_helper_3i(ldl, t1, t0, t1, ctx->mem_idx);
         gen_store_gpr(t1, rt);
         opn = "ldl";
         break;
     case OPC_SDL:
         save_cpu_state(ctx, 1);
         gen_load_gpr(t1, rt);
-        tcg_gen_helper_0_2i(do_sdl, t0, t1, ctx->mem_idx);
+        gen_helper_2i(sdl, t0, t1, ctx->mem_idx);
         opn = "sdl";
         break;
     case OPC_LDR:
         save_cpu_state(ctx, 1);
         gen_load_gpr(t1, rt);
-        tcg_gen_helper_1_2i(do_ldr, t1, t0, t1, ctx->mem_idx);
+        gen_helper_3i(ldr, t1, t0, t1, ctx->mem_idx);
         gen_store_gpr(t1, rt);
         opn = "ldr";
         break;
     case OPC_SDR:
         save_cpu_state(ctx, 1);
         gen_load_gpr(t1, rt);
-        tcg_gen_helper_0_2i(do_sdr, t0, t1, ctx->mem_idx);
+        gen_helper_2i(sdr, t0, t1, ctx->mem_idx);
         opn = "sdr";
         break;
 #endif
@@ -1143,27 +1093,27 @@ static void gen_ldst (DisasContext *ctx, uint32_t opc, int rt,
     case OPC_LWL:
         save_cpu_state(ctx, 1);
 	gen_load_gpr(t1, rt);
-        tcg_gen_helper_1_2i(do_lwl, t1, t0, t1, ctx->mem_idx);
+        gen_helper_3i(lwl, t1, t0, t1, ctx->mem_idx);
         gen_store_gpr(t1, rt);
         opn = "lwl";
         break;
     case OPC_SWL:
         save_cpu_state(ctx, 1);
         gen_load_gpr(t1, rt);
-        tcg_gen_helper_0_2i(do_swl, t0, t1, ctx->mem_idx);
+        gen_helper_2i(swl, t0, t1, ctx->mem_idx);
         opn = "swr";
         break;
     case OPC_LWR:
         save_cpu_state(ctx, 1);
 	gen_load_gpr(t1, rt);
-        tcg_gen_helper_1_2i(do_lwr, t1, t0, t1, ctx->mem_idx);
+        gen_helper_3i(lwr, t1, t0, t1, ctx->mem_idx);
         gen_store_gpr(t1, rt);
         opn = "lwr";
         break;
     case OPC_SWR:
         save_cpu_state(ctx, 1);
         gen_load_gpr(t1, rt);
-        tcg_gen_helper_0_2i(do_swr, t0, t1, ctx->mem_idx);
+        gen_helper_2i(swr, t0, t1, ctx->mem_idx);
         opn = "swr";
         break;
     case OPC_LL:
@@ -1194,14 +1144,14 @@ static void gen_flt_ldst (DisasContext *ctx, uint32_t opc, int ft,
                           int base, int16_t offset)
 {
     const char *opn = "flt_ldst";
-    TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
+    TCGv t0 = tcg_temp_local_new();
 
     if (base == 0) {
         tcg_gen_movi_tl(t0, offset);
     } else if (offset == 0) {
         gen_load_gpr(t0, base);
     } else {
-        TCGv t1 = tcg_temp_local_new(TCG_TYPE_TL);
+        TCGv t1 = tcg_temp_local_new();
 
         gen_load_gpr(t0, base);
         tcg_gen_movi_tl(t1, offset);
@@ -1213,41 +1163,47 @@ static void gen_flt_ldst (DisasContext *ctx, uint32_t opc, int ft,
     switch (opc) {
     case OPC_LWC1:
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
+            TCGv t1 = tcg_temp_new();
 
-            tcg_gen_qemu_ld32s(fp0, t0, ctx->mem_idx);
+            tcg_gen_qemu_ld32s(t1, t0, ctx->mem_idx);
+            tcg_gen_trunc_tl_i32(fp0, t1);
             gen_store_fpr32(fp0, ft);
-            tcg_temp_free(fp0);
+            tcg_temp_free(t1);
+            tcg_temp_free_i32(fp0);
         }
         opn = "lwc1";
         break;
     case OPC_SWC1:
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
+            TCGv t1 = tcg_temp_new();
 
             gen_load_fpr32(fp0, ft);
-            tcg_gen_qemu_st32(fp0, t0, ctx->mem_idx);
-            tcg_temp_free(fp0);
+            tcg_gen_extu_i32_tl(t1, fp0);
+            tcg_gen_qemu_st32(t1, t0, ctx->mem_idx);
+            tcg_temp_free(t1);
+            tcg_temp_free_i32(fp0);
         }
         opn = "swc1";
         break;
     case OPC_LDC1:
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             tcg_gen_qemu_ld64(fp0, t0, ctx->mem_idx);
             gen_store_fpr64(ctx, fp0, ft);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "ldc1";
         break;
     case OPC_SDC1:
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, ft);
             tcg_gen_qemu_st64(fp0, t0, ctx->mem_idx);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "sdc1";
         break;
@@ -1267,7 +1223,7 @@ static void gen_arith_imm (CPUState *env, DisasContext *ctx, uint32_t opc,
 {
     target_ulong uimm;
     const char *opn = "imm arith";
-    TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
+    TCGv t0 = tcg_temp_local_new();
 
     if (rt == 0 && opc != OPC_ADDI && opc != OPC_DADDI) {
         /* If no destination, treat it as a NOP.
@@ -1313,8 +1269,8 @@ static void gen_arith_imm (CPUState *env, DisasContext *ctx, uint32_t opc,
     switch (opc) {
     case OPC_ADDI:
         {
-            TCGv r_tmp1 = tcg_temp_new(TCG_TYPE_TL);
-            TCGv r_tmp2 = tcg_temp_new(TCG_TYPE_TL);
+            TCGv r_tmp1 = tcg_temp_new();
+            TCGv r_tmp2 = tcg_temp_new();
             int l1 = gen_new_label();
 
             save_cpu_state(ctx, 1);
@@ -1343,8 +1299,8 @@ static void gen_arith_imm (CPUState *env, DisasContext *ctx, uint32_t opc,
 #if defined(TARGET_MIPS64)
     case OPC_DADDI:
         {
-            TCGv r_tmp1 = tcg_temp_new(TCG_TYPE_TL);
-            TCGv r_tmp2 = tcg_temp_new(TCG_TYPE_TL);
+            TCGv r_tmp1 = tcg_temp_new();
+            TCGv r_tmp2 = tcg_temp_new();
             int l1 = gen_new_label();
 
             save_cpu_state(ctx, 1);
@@ -1416,12 +1372,12 @@ static void gen_arith_imm (CPUState *env, DisasContext *ctx, uint32_t opc,
             /* rotr is decoded as srl on non-R2 CPUs */
             if (env->insn_flags & ISA_MIPS32R2) {
                 if (uimm != 0) {
-                    TCGv r_tmp1 = tcg_temp_new(TCG_TYPE_I32);
+                    TCGv_i32 r_tmp1 = tcg_temp_new_i32();
 
                     tcg_gen_trunc_tl_i32(r_tmp1, t0);
                     tcg_gen_rotri_i32(r_tmp1, r_tmp1, uimm);
                     tcg_gen_ext_i32_tl(t0, r_tmp1);
-                    tcg_temp_free(r_tmp1);
+                    tcg_temp_free_i32(r_tmp1);
                 }
                 opn = "rotr";
             } else {
@@ -1520,8 +1476,8 @@ static void gen_arith (CPUState *env, DisasContext *ctx, uint32_t opc,
                        int rd, int rs, int rt)
 {
     const char *opn = "arith";
-    TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
-    TCGv t1 = tcg_temp_local_new(TCG_TYPE_TL);
+    TCGv t0 = tcg_temp_local_new();
+    TCGv t1 = tcg_temp_local_new();
 
     if (rd == 0 && opc != OPC_ADD && opc != OPC_SUB
        && opc != OPC_DADD && opc != OPC_DSUB) {
@@ -1541,8 +1497,8 @@ static void gen_arith (CPUState *env, DisasContext *ctx, uint32_t opc,
     switch (opc) {
     case OPC_ADD:
         {
-            TCGv r_tmp1 = tcg_temp_new(TCG_TYPE_TL);
-            TCGv r_tmp2 = tcg_temp_new(TCG_TYPE_TL);
+            TCGv r_tmp1 = tcg_temp_new();
+            TCGv r_tmp2 = tcg_temp_new();
             int l1 = gen_new_label();
 
             save_cpu_state(ctx, 1);
@@ -1572,8 +1528,8 @@ static void gen_arith (CPUState *env, DisasContext *ctx, uint32_t opc,
         break;
     case OPC_SUB:
         {
-            TCGv r_tmp1 = tcg_temp_new(TCG_TYPE_TL);
-            TCGv r_tmp2 = tcg_temp_new(TCG_TYPE_TL);
+            TCGv r_tmp1 = tcg_temp_new();
+            TCGv r_tmp2 = tcg_temp_new();
             int l1 = gen_new_label();
 
             save_cpu_state(ctx, 1);
@@ -1603,8 +1559,8 @@ static void gen_arith (CPUState *env, DisasContext *ctx, uint32_t opc,
 #if defined(TARGET_MIPS64)
     case OPC_DADD:
         {
-            TCGv r_tmp1 = tcg_temp_new(TCG_TYPE_TL);
-            TCGv r_tmp2 = tcg_temp_new(TCG_TYPE_TL);
+            TCGv r_tmp1 = tcg_temp_new();
+            TCGv r_tmp2 = tcg_temp_new();
             int l1 = gen_new_label();
 
             save_cpu_state(ctx, 1);
@@ -1630,8 +1586,8 @@ static void gen_arith (CPUState *env, DisasContext *ctx, uint32_t opc,
         break;
     case OPC_DSUB:
         {
-            TCGv r_tmp1 = tcg_temp_new(TCG_TYPE_TL);
-            TCGv r_tmp2 = tcg_temp_new(TCG_TYPE_TL);
+            TCGv r_tmp1 = tcg_temp_new();
+            TCGv r_tmp2 = tcg_temp_new();
             int l1 = gen_new_label();
 
             save_cpu_state(ctx, 1);
@@ -1735,14 +1691,14 @@ static void gen_arith (CPUState *env, DisasContext *ctx, uint32_t opc,
                 tcg_gen_andi_tl(t0, t0, 0x1f);
                 tcg_gen_brcondi_tl(TCG_COND_EQ, t0, 0, l1);
                 {
-                    TCGv r_tmp1 = tcg_temp_new(TCG_TYPE_I32);
-                    TCGv r_tmp2 = tcg_temp_new(TCG_TYPE_I32);
+                    TCGv_i32 r_tmp1 = tcg_temp_new_i32();
+                    TCGv_i32 r_tmp2 = tcg_temp_new_i32();
 
                     tcg_gen_trunc_tl_i32(r_tmp1, t0);
                     tcg_gen_trunc_tl_i32(r_tmp2, t1);
                     tcg_gen_rotr_i32(r_tmp1, r_tmp1, r_tmp2);
-                    tcg_temp_free(r_tmp1);
-                    tcg_temp_free(r_tmp2);
+                    tcg_temp_free_i32(r_tmp1);
+                    tcg_temp_free_i32(r_tmp2);
                     tcg_gen_br(l2);
                 }
                 gen_set_label(l1);
@@ -1827,7 +1783,7 @@ static void gen_arith (CPUState *env, DisasContext *ctx, uint32_t opc,
 static void gen_HILO (DisasContext *ctx, uint32_t opc, int reg)
 {
     const char *opn = "hilo";
-    TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
+    TCGv t0 = tcg_temp_local_new();
 
     if (reg == 0 && (opc == OPC_MFHI || opc == OPC_MFLO)) {
         /* Treat as NOP. */
@@ -1869,8 +1825,8 @@ static void gen_muldiv (DisasContext *ctx, uint32_t opc,
                         int rs, int rt)
 {
     const char *opn = "mul/div";
-    TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
-    TCGv t1 = tcg_temp_local_new(TCG_TYPE_TL);
+    TCGv t0 = tcg_temp_local_new();
+    TCGv t1 = tcg_temp_local_new();
 
     gen_load_gpr(t0, rs);
     gen_load_gpr(t1, rt);
@@ -1882,9 +1838,9 @@ static void gen_muldiv (DisasContext *ctx, uint32_t opc,
             tcg_gen_brcondi_tl(TCG_COND_EQ, t1, 0, l1);
             {
                 int l2 = gen_new_label();
-                TCGv r_tmp1 = tcg_temp_local_new(TCG_TYPE_I32);
-                TCGv r_tmp2 = tcg_temp_local_new(TCG_TYPE_I32);
-                TCGv r_tmp3 = tcg_temp_local_new(TCG_TYPE_I32);
+                TCGv_i32 r_tmp1 = tcg_temp_local_new_i32();
+                TCGv_i32 r_tmp2 = tcg_temp_local_new_i32();
+                TCGv_i32 r_tmp3 = tcg_temp_local_new_i32();
 
                 tcg_gen_trunc_tl_i32(r_tmp1, t0);
                 tcg_gen_trunc_tl_i32(r_tmp2, t1);
@@ -1898,9 +1854,9 @@ static void gen_muldiv (DisasContext *ctx, uint32_t opc,
                 tcg_gen_rem_i32(r_tmp2, r_tmp1, r_tmp2);
                 tcg_gen_ext_i32_tl(cpu_LO[0], r_tmp3);
                 tcg_gen_ext_i32_tl(cpu_HI[0], r_tmp2);
-                tcg_temp_free(r_tmp1);
-                tcg_temp_free(r_tmp2);
-                tcg_temp_free(r_tmp3);
+                tcg_temp_free_i32(r_tmp1);
+                tcg_temp_free_i32(r_tmp2);
+                tcg_temp_free_i32(r_tmp3);
             }
             gen_set_label(l1);
         }
@@ -1913,9 +1869,9 @@ static void gen_muldiv (DisasContext *ctx, uint32_t opc,
             tcg_gen_ext32s_tl(t1, t1);
             tcg_gen_brcondi_tl(TCG_COND_EQ, t1, 0, l1);
             {
-                TCGv r_tmp1 = tcg_temp_new(TCG_TYPE_I32);
-                TCGv r_tmp2 = tcg_temp_new(TCG_TYPE_I32);
-                TCGv r_tmp3 = tcg_temp_new(TCG_TYPE_I32);
+                TCGv_i32 r_tmp1 = tcg_temp_new_i32();
+                TCGv_i32 r_tmp2 = tcg_temp_new_i32();
+                TCGv_i32 r_tmp3 = tcg_temp_new_i32();
 
                 tcg_gen_trunc_tl_i32(r_tmp1, t0);
                 tcg_gen_trunc_tl_i32(r_tmp2, t1);
@@ -1923,9 +1879,9 @@ static void gen_muldiv (DisasContext *ctx, uint32_t opc,
                 tcg_gen_remu_i32(r_tmp1, r_tmp1, r_tmp2);
                 tcg_gen_ext_i32_tl(cpu_LO[0], r_tmp3);
                 tcg_gen_ext_i32_tl(cpu_HI[0], r_tmp1);
-                tcg_temp_free(r_tmp1);
-                tcg_temp_free(r_tmp2);
-                tcg_temp_free(r_tmp3);
+                tcg_temp_free_i32(r_tmp1);
+                tcg_temp_free_i32(r_tmp2);
+                tcg_temp_free_i32(r_tmp3);
             }
             gen_set_label(l1);
         }
@@ -1933,17 +1889,17 @@ static void gen_muldiv (DisasContext *ctx, uint32_t opc,
         break;
     case OPC_MULT:
         {
-            TCGv r_tmp1 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv r_tmp2 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 r_tmp1 = tcg_temp_new_i64();
+            TCGv_i64 r_tmp2 = tcg_temp_new_i64();
 
             tcg_gen_ext_tl_i64(r_tmp1, t0);
             tcg_gen_ext_tl_i64(r_tmp2, t1);
             tcg_gen_mul_i64(r_tmp1, r_tmp1, r_tmp2);
-            tcg_temp_free(r_tmp2);
+            tcg_temp_free_i64(r_tmp2);
             tcg_gen_trunc_i64_tl(t0, r_tmp1);
             tcg_gen_shri_i64(r_tmp1, r_tmp1, 32);
             tcg_gen_trunc_i64_tl(t1, r_tmp1);
-            tcg_temp_free(r_tmp1);
+            tcg_temp_free_i64(r_tmp1);
             tcg_gen_ext32s_tl(cpu_LO[0], t0);
             tcg_gen_ext32s_tl(cpu_HI[0], t1);
         }
@@ -1951,19 +1907,19 @@ static void gen_muldiv (DisasContext *ctx, uint32_t opc,
         break;
     case OPC_MULTU:
         {
-            TCGv r_tmp1 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv r_tmp2 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 r_tmp1 = tcg_temp_new_i64();
+            TCGv_i64 r_tmp2 = tcg_temp_new_i64();
 
             tcg_gen_ext32u_tl(t0, t0);
             tcg_gen_ext32u_tl(t1, t1);
             tcg_gen_extu_tl_i64(r_tmp1, t0);
             tcg_gen_extu_tl_i64(r_tmp2, t1);
             tcg_gen_mul_i64(r_tmp1, r_tmp1, r_tmp2);
-            tcg_temp_free(r_tmp2);
+            tcg_temp_free_i64(r_tmp2);
             tcg_gen_trunc_i64_tl(t0, r_tmp1);
             tcg_gen_shri_i64(r_tmp1, r_tmp1, 32);
             tcg_gen_trunc_i64_tl(t1, r_tmp1);
-            tcg_temp_free(r_tmp1);
+            tcg_temp_free_i64(r_tmp1);
             tcg_gen_ext32s_tl(cpu_LO[0], t0);
             tcg_gen_ext32s_tl(cpu_HI[0], t1);
         }
@@ -2003,29 +1959,29 @@ static void gen_muldiv (DisasContext *ctx, uint32_t opc,
         opn = "ddivu";
         break;
     case OPC_DMULT:
-        tcg_gen_helper_0_2(do_dmult, t0, t1);
+        gen_helper_dmult(t0, t1);
         opn = "dmult";
         break;
     case OPC_DMULTU:
-        tcg_gen_helper_0_2(do_dmultu, t0, t1);
+        gen_helper_dmultu(t0, t1);
         opn = "dmultu";
         break;
 #endif
     case OPC_MADD:
         {
-            TCGv r_tmp1 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv r_tmp2 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 r_tmp1 = tcg_temp_new_i64();
+            TCGv_i64 r_tmp2 = tcg_temp_new_i64();
 
             tcg_gen_ext_tl_i64(r_tmp1, t0);
             tcg_gen_ext_tl_i64(r_tmp2, t1);
             tcg_gen_mul_i64(r_tmp1, r_tmp1, r_tmp2);
             tcg_gen_concat_tl_i64(r_tmp2, cpu_LO[0], cpu_HI[0]);
             tcg_gen_add_i64(r_tmp1, r_tmp1, r_tmp2);
-            tcg_temp_free(r_tmp2);
+            tcg_temp_free_i64(r_tmp2);
             tcg_gen_trunc_i64_tl(t0, r_tmp1);
             tcg_gen_shri_i64(r_tmp1, r_tmp1, 32);
             tcg_gen_trunc_i64_tl(t1, r_tmp1);
-            tcg_temp_free(r_tmp1);
+            tcg_temp_free_i64(r_tmp1);
             tcg_gen_ext32s_tl(cpu_LO[0], t0);
             tcg_gen_ext32s_tl(cpu_LO[1], t1);
         }
@@ -2033,8 +1989,8 @@ static void gen_muldiv (DisasContext *ctx, uint32_t opc,
         break;
     case OPC_MADDU:
        {
-            TCGv r_tmp1 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv r_tmp2 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 r_tmp1 = tcg_temp_new_i64();
+            TCGv_i64 r_tmp2 = tcg_temp_new_i64();
 
             tcg_gen_ext32u_tl(t0, t0);
             tcg_gen_ext32u_tl(t1, t1);
